#include <inttypes.h>
#include <stdio.h>
#include <netinet/in.h>
#include <math.h>
#include <stdlib.h>

int main(int argc, char *argv[])
{
  double samplerate = 44100.0;
  double frequency  = atof(argv[1]);
  int samples = atoi(argv[2]);
  double increment = 2*M_PI*frequency/samplerate;
  double x = 0.0;
  int16_t sample[2];

  fprintf(stderr, "increment = %g\n", increment);

  while ( samples-- ) {
    int16_t s = htons((int16_t)(sin(x)*32767.0));
    sample[0] = sample[1] = s;
    fwrite(sample, 2, 2, stdout);
    
    x = fmod(x+increment, 2*M_PI);
  }

  return 0;
}
